#ifndef MESH_H
#define MESH_H

#include "vertex.h"
#include "triangle.h"
#include "builder.h"
#include "updater.h"

class Mesh
{
	public:

		float position [3];
		float color    [4];

		inline Mesh(void);
		virtual ~Mesh(void) { }

		virtual void create  (const Builder & b)           { b.build(this->vertices, this->triangles); }
		virtual void destroy (void)                        { }
		virtual void update  (const Updater & u, float dt) { u.update(this->vertices, this->triangles, dt); }
		virtual void render  (void) const                  { }

	protected:

		VertexVector   vertices;
		TriangleVector triangles;
};

inline Mesh::Mesh(void)
{
	this->position[0] = 0.0f;
	this->position[1] = 0.0f;
	this->position[2] = 0.0f;

	this->color[0] = 0.8f;
	this->color[1] = 0.8f;
	this->color[2] = 0.8f;
	this->color[3] = 1.0f;
}

#endif // MESH_H
