#ifndef MESHIMMEDIATEMODE_H
#define MESHIMMEDIATEMODE_H

#include "mesh.h"
#include "fw.h"

class MeshImmediateMode : public Mesh
{
	public:

		virtual void render(void) const
		{
			glBegin(GL_TRIANGLES);
				for (size_t i=0; i<this->triangles.size(); ++i)
				{
					const Triangle & t = this->triangles[i];
					for (int j=0; j<3; ++j)
					{
						const unsigned int index = t.vertices[j];
						const Vertex & v = this->vertices[index];
						glNormal3fv   (v.normal);
						glColor4ubv   (v.color);
						glTexCoord2fv (v.texcoord);
						glVertex3fv   (v.position);
					}
				}
			glEnd();
		}
};

#endif // MESHIMMEDIATEMODE_H
